<?php 
## USER SETTINGS ###
$allowedDepth=0; 		// Maximum folder depth, 0 = only same folder as the php file. 1 = The folders that are in the same folder as this script can be accessed. 
$thumbPath = "./.thumbs/";
$warnings=true;			// if true shows warnings, false hides all warnings
$htwarnings=true;		// hide just htaccess missmatch warnings
$pdfQuartzwarnings=true;
$privateFiles = array("index.php",".php","~",".html");  // File types, files, or anything which ends matches something on this list will not be displayed. in lowercase
// files that start with . will be hidden by default
$privateFolders = array("test1","test2");
## USER SETTINGS END ###

/* DEBUG / Installation notes
Warning: Unknown: failed to open stream: Permission denied in Unknown on line 0 == selinux problem
500 Internal Server Error == Usually permission issue. try chmod 755 <folder> and chmod 644 <file> .	
#suphp
yum -y install php php-gd php-mcrypt php-pear  php-mysql php-xml php-mbstring php-devel gcc pcre-devel
rpm -ivh http://pkgs.repoforge.org/mod_suphp/mod_suphp-0.7.1-1.el6.rf.x86_64.rpm



## IMAGICK
yum install gcc php-devel php-pear
yum install ImageMagick ImageMagick-devel
pecl channel-update pecl.php.net
pecl install imagick
echo "extension=imagick.so" > /etc/php.d/imagick.ini
service httpd reload

## ICONS
httpd.conf inside <IfModule alias_module>  add the following

        Alias /icons/ "/usr/share/httpd/icons/"
        <Directory "/usr/share/httpd/icons">
                Options FollowSymlinks
                AllowOverride None
                Require all granted
        </Directory>

and copy icons and font to folder called fv

yum install php-gd

*/
echo "
<script type=\"text/javascript\">
$(window).load(function(){
 $('.fullcontainer').find('img').each(function(){
  var imgClass = (this.width/this.height > 1) ? 'wide' : 'tall';
  $(this).addClass(imgClass);
 })
})
</script>
";
$version="0.40";
date_default_timezone_set('Asia/Tokyo');	# to prevent php warning each time script is run
global $thumbPath,$supported,$warnings,$htwarnings,$thumbWidth,$pdfQuartzwarnings,$pics;

$supported = array(".jpg",".jpeg",".png",".txt",".gif",".log",".pdf",".docx",".doc",".xlsx",".xls",".zip",".rar",".tar",".gz",".7z",".iso",".bin",".img"); // Files that have either icon or thumbnail
$supportedthumbs= array(".jpg",".jpeg",".png",".txt",".gif",".log",".pdf");	//Files that will have thumbnails generated
$testdir="";		
$dir = "./";	# set dir to something
$defaultview = "grid";   # sets the default view, (grid or list)
$view=$defaultview;
$thumbWidth = 500;
?> 
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<style type="text/css">
body, html{

}
a{
	text-decoration: none;
}
a.footerlink{
	color:"#0000FF"
}
.helper {
	white-space: nowrap;
	overflow: hidden;
   	 display: inline-block;
   	 height: 100%;
   	 vertical-align: middle;
}
#header {
	white-space: nowrap;
	overflow: hidden;
   	 background-color:GhostWhite;
   	 color:black;

   	 padding:5px;
}

#footer {
	white-space: nowrap;
	overflow: hidden;
   	 background-color:gray;
  	  color:white;
   	 clear:both;
   	 text-align:center;
   	 padding:0px;
}
#settingbar {
	 flex-wrap:nowrap;
	display: flex;
	white-space: nowrap;
	overflow: hidden;
    background-color:DarkGray;
    color:white;
    padding:2px;
}
#title {
	flex:1;
	width:auto;
	white-space: nowrap;
	overflow: hidden;
	text-align:left;
	float:left;
	margin:0;
	padding:0;
	color:black;
}
#title2 {
	width:auto;
	white-space: nowrap;
	overflow: hidden;
	text-align:center;
	float:left;
	margin:0;
	padding:0;
	color:black;
	text-overflow: ellipsis;
}
#view {
    color:white;
}

.fileinfo{
	display: flex;
	height:20px;
	white-space: nowrap;
	overflow: hidden;
	background-color:Lavender;
}
.fileinfo2{
	display: flex;
	height:20px;
	white-space: nowrap;
	overflow: hidden;
	background-color:GhostWhite;
}
#fileinfo3{
	display: flex;
	height:20px;
	overflow: hidden;
	white-space: nowrap;
	background-color:gray;
	text-overflow: ellipsis;
}
.fileicon{

	height:20px;
	width:20px;
	margin-left: 0px;
	margin-right: 6px;
	float:left;
}
.fileicon1{
	height:20px;
	width:20px;
	margin-left: 0px;
	margin-right: 6px;
	float:left;
}

.name{
	flex:1;
	overflow: hidden;
	text-overflow: ellipsis;
	white-space: nowrap;
	min-width: 50px;
	margin-left: 1px;
	float:left;
}
.type{
	overflow: hidden;
	text-overflow: ellipsis;
	white-space: nowrap;
	text-align:right;
	padding-right:2px;
	width:40px;
	float:right;
}
.modified{
	white-space: nowrap;
	overflow: hidden;
	text-overflow: ellipsis;
	padding-left:2px;
	text-align: right;
	padding-right: 1px;
	width:150px;
	float:right;
}
.spacer{
	white-space: nowrap;
	float:right;
	width:1px;
	background-color:black;
}
.spacer2{
	white-space: nowrap;
	float:left;
	width:1px;
	background-color:black;
	
}
.filesize{
	white-space: nowrap;
	overflow: hidden;
	text-align:right;
	padding-right:2px;
	width:90px;
	float:right;
}
.allcontainer{
	white-space: nowrap;
	overflow: hidden;
	background-color:Lavender;
	overflow:hidden;
}
.container {
    	height:168px;
    	margin:2px;
    	float:left;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	width: 202px;
    	border: 2px solid black;
}
.container2 {
	white-space: nowrap;
	overflow: hidden;
	float:left;
	width:200px;
}
.pictures {
	float:left;
	height: 150px;      
	width: 200px;
	white-space: nowrap;
	text-align: center; 
	margin: 0;
}
.picture{
	vertical-align: middle;
	max-height: 150px;
	max-width: 200px;
}
.picturetext {
   	float:left;
	width:90%;
	height:20px;
	overflow: hidden;
	text-decoration: none;
	text-overflow: ellipsis;
}
.download {
 	float:left;
	width:20px;
	height:20px;
}
.downloadlist {
	margin-left:2px;
 	float:left;
	width:20px;
	height:20px;
}
.cube {
	width:16px;
}
.icon {
	width:18px;
	height:18px;
	padding:2px;
}
.baricon{
	float:left;
	height:16px;
	overflow:hidden;
	padding:2px;	
}
.baricon2{
	white-space: nowrap;
	height:16px;
	float:right;
	overflow:hidden;
	padding:2px;	
}
.thumb{
	width:50px;
	height:50px;
}
.downloadicon{
	width:16px;
	height:16px;
}
.full {
    display:block;

    margin:auto;
max-width:100%;
max-height:100%;
}
.selectpictures {
	height:100%;
	white-space: nowrap;
	text-align: center; 
	margin: 0;

}
.fullcontainer {
    width: 100%;
    height: 95%;
    background: Lavender;
    margin: 0 auto;
}
.fullcontainer img.wide {
    max-width: 100%;
    max-height: 100%;
    height: auto;
}
.fullcontainer img.tall {
    max-height: 100%;
    max-width: 100%;
    width: auto;
}​
.selectcontainer2 {
	white-space: nowrap;
	float:left;
	height:50%;
    	width: 100%;
}
.selectcontainer {
    	height:90%;
    	width: 80px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.currentselectcontainer {
    	height:90%;
    	width: 80px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid white;
}
.selectpicture{
	vertical-align: middle;
	max-height: 100%;
	max-width: 100%;
}
.selectpicturetext {
   	float:left;
   	font-size:12px;
	width:85%;
	height:10%;
	overflow: hidden;
	text-decoration: none;
	text-overflow: ellipsis;
	
}
.selectdownload {
 	float:left;
	width:10%;
	height:9%;
	margin-right:4px;
}
.top{
   float:left;
   height: 90%;
   width:100%;

}
.bottom{
 white-space: nowrap;
 position:absolute;
 height:10%;
 background:DarkGray;
 left:0;
 right:0;
 margin:8px;
 bottom: 0px;
 overflow-y: hidden;
 overflow-x: hidden;
}
.allign{
	text-align: center;
   	height:100%;
	margin: 0 auto;
}
.buttonalign{
    position: relative;
    top: 50%;
    left: 50%;
    transform: translateX(-50%) translateY(-50%);
}
.first {
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.firstg {
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid gray;
}
.last {
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.lastg {
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid gray;
}
.previous {
	line-height: 100%;       /* the same as your div height */
    	height:90%;
    	width: 50px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.previousg {
	line-height: 100%;       /* the same as your div height */
    	height:90%;
    	width: 50px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid gray;
}
.previous5 {
	line-height: 100%;       /* the same as your div height */
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.previousg5 {
	line-height: 100%;       /* the same as your div height */
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid gray;
}
.next {
    	height:90%;
    	width: 50px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.nextg {
    	height:90%;
    	width: 50px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid gray;
}
.next5 {
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid black;
}
.nextg5 {
    	height:90%;
    	width: 40px;
    	margin:1px;
    	display: inline-block;
    	overflow: hidden;
    	text-overflow: ellipsis;
    	border: 2px solid gray;
}
</style>

<title>File viewer</title>

</head>
<body>
<?php

if(file_exists("./.icons/")){
	$iconpath="./.icons";
}else{
	$iconpath="/icons/fv";
}
$root = "";	# clean("http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]");
if(isset($_GET["view"]))	// else if view type is set
{
	$view=htmlentities($_GET["view"],ENT_COMPAT,"UTF-8");
}
if(isset($_GET["about"])){	// If about is pressed
	echo "version ",$version,"<br>";
	echo "Erkki Hurme<br><br>";
	echo "All Icons are used under Creative Commons Attribution 2.5 License from";
	echo "<br><a href=http://www.famfamfam.com/lab/icons/silk/> famfamfam.com/lab/icons/silk/ </a><br><br>";
	
	echo '<a href=?view=';
	echo $view;
	echo ' class="footerlink" > Return to File viewer</a>';
	echo '<FORM action="#" method="get" enctype="multipart/form-data">';
	echo '<input type="submit" value="Delete thumbs" name="delete">';
	echo '</FORM>';
}
else{
	if(isset($_GET["reset"])) // If home/reset is pressed
	{
		$dir = "./";
	}
	elseif(isset($_GET["dir"]))	// Else if tries to change shown folder
	{
		$tempdir = htmlentities(rtrim($_GET["dir"], "/") . "/",ENT_COMPAT,"UTF-8"); // remove trailing / and remove unwanted characters
		if (strpos(realpath($tempdir),dirname(__FILE__)) !== FALSE)			// Check if path is inside script folder
		{
			if(strpos($dir,"./")===FALSE){					// If path doesn't start with ./ add it
				$tempdir= "./" . $tempdir;
			}
			if(substr_count($tempdir,'/') > $allowedDepth+1 || $tempdir== "."){ 	// If tries to access folder that is deeper than allowedDepth
				$tempdir = "./";
			}else{
				$count = substr_count($tempdir,'/');
				$testdir=$tempdir;
				for($i = 0; $i < $count; $i++ ){	
					$tempar=checkHtaccess($testdir);		
					if(!$tempar['enable'] || !privatecheck($testdir,$privateFiles,$privateFolders)){	
						$tempdir = "./";
						break;
					}
					$testdir=dirname($testdir);
				}
			}
		$dir=$tempdir;
		}
		else // Not inside script folder
		{
			$dir = "./";  
		}
	}
	else # default to root folder
	{
		$dir="./";
	}
$files['files']=scandir($dir);			// save file list to array

if(isset($_GET["delete"])){		// if delete is set
	echo "Removing thumbs.....";
	if(removethumbs("./.thumbs/")){ // try to delete  the thumbs
		echo "<br>Removed thumbs";
	}else{
		echo "<br>Removing thumbs failed.";
	}
}else // Delete not set continuing
{
	$files = removeExtra($files,$dir,$allowedDepth,	$privateFiles,$privateFolders);	 // Remove private files + and directories if necessary
	if($view=="jpg"){
		echo '<div class="top">';
		functionbar($dir,$root,$iconpath,$files,$view,$defaultview);	
	}else{
		functionbar($dir,$root,$iconpath,null,$view,$defaultview);	
	}
				// Create the Top bar
	loopfiles($files,$dir, "thumbs",$iconpath,$view);		// Generate the thumbnails
	if($view=="grid"){					// Generate grid view if it's set
			loopfiles($files,$dir,"grid",$iconpath,$view);
	}
	elseif($view=="list"){					// else generate the list view
			infobar($iconpath);
		loopfiles($files,$dir,"list",$iconpath,$view);
			infobar($iconpath);
	}elseif($view=="jpg"){
		loopfiles($files,$dir,"jpg",$iconpath,$view);
	}else{
		echo "something went wrong";			// if nothing is set print error, shoudln't happen
		}
	}
	if($view=="jpg"){
	}else{
		functionbar($dir,$root,$iconpath,null,$view,$defaultview);
	}
}

// This function is from  Jeffrey Sambells, http://jeffreysambells.com/2012/10/25/human-readable-filesize-php
function human_filesize($bytes, $decimals = 1) {   
    $size = array('B','kiB','MiB','GiB','TiB','PiB','EiB','ZiB','YiB');
    $factor = floor((strlen($bytes) - 1) / 3);
    return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) ." ". @$size[$factor];
}

function removethumbs($thumbdir){			// Removes thumbnails recursively
	$test=true;
	if (! is_dir($thumbdir)) {			// Fail if not folder
        	$test=false;
    	}else
	{
		if (substr($thumbdir, strlen($thumbdir) - 1, 1) != '/') {	// Check if last char is / and if not add it 
       			$thumbdir .= '/';
   		}
   		$files = glob($thumbdir . '*', GLOB_MARK);			// Make a list of all files and folders and sub folders and files in them
   		foreach ($files as $file) {					// loop through the files
       	 		if (is_dir($file)) {					// if it's folder call itself again
          			if(removethumbs($file)==false){
					$test=false;
					if($GLOBALS['warnings']){echo "error removing dir error code 5";}
					break;
				}
      			}else{
	     		   	unlink($file); 					// else remove the thumbnail
        		}
    		}
		if(!rmdir($thumbdir)){ // if removing the folder fails
			$test=false;	// fail the test
			if($thumbdir=="./.thumbs/"){	// if the folder is the ./.thumbs display error message but don't fail 
    				if($GLOBALS['warnings']){echo "<br>Can't remove ./.thumbs/ folder automatically. Please remove it manually.<br>";}
    				$test=true;
			}
		}
	}
   return $test;	
}

function clean($url) {
    $parts = parse_url($url);
    return $parts['scheme'] . '://' . $parts['host'] . $parts['path'];
}

function functionbar($dir,$root,$iconpath,$files,$view,$defaultview){ // Generate the functionbar
if($files!=null){
	foreach($files['files'] as $file){
		$ext=pathinfo($file, PATHINFO_EXTENSION);
		if($ext=="jpg" || $ext =="png" || $ext =="gif" || $ext== "jpeg"){
			$pics[]=$file;
		}
	}
	if(isset($_GET['pic'])){
		$offset=filter_input(INPUT_GET, 'pic', FILTER_VALIDATE_INT);
	}else{
		$offset=0;
	}
	$GLOBALS['pics']=$pics;
}
echo '<div id="settingbar">';
	echo '<div id="title2">File viewer&nbsp;</div>';
		echo '<a href="',$root,'?view=',$defaultview,'&reset=1"><img alt="Home" src="' . $iconpath . '/house.png" class="baricon"></a>';	
	#if($dir !== "./"){
		echo '<a href="?view=',$view,'&dir=',dirname($dir),'"><img alt="Parent folder" src="' . $iconpath . '/resultset_previous.png" class="baricon"></a>';	
	#}else{
	#	$actual_link = "http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
	#	$actual_link = clean($actual_link);
	#	echo '<a href="',substr($actual_link, 0, strrpos(trim($actual_link,"/"), "/")),'"><img alt="Parent folder" src="' . $iconpath . '/resultset_previous.png" class="baricon"></a>';	
	#}
	
	
	
	echo '<div id="title">';
	$depth= substr_count($dir , '/')-2; // Calculate the depth
	$path[] = $dir;			    // Start making array with paths
	for ( $x=0;$x<$depth;$x++){	    // loop until all paths are in the array
	$path[] = dirname($path[$x]);
	}
	end($path);				// move pointer to end of array
	if($path[key($path)]!=="./"){		// read from the pointer and if the last value in array is not ./ add it
	$path[]="./";
	}
	$path = array_reverse($path);		// reverse the array
	$lastpath=end($path);
	foreach ($path as $link){		// loop through the paths
		if($lastpath==$link && $link!="./"){	// if the path is last and it's not ./
			echo "", basename($link)," /";
		}
		elseif($lastpath==$link && $link=="./"){		// if path is ./ and last get the current folder name 
			echo "", basename(getcwd())," /";
		}elseif($link=="./"){					// get current folder path for root
			echo '<a href="?view='.$view.'&dir=',$link,'">',"",basename(getcwd()),'</a>  / ';
		}
		else
		{							// everything else as a link
			echo '<a href="?view='.$view.'&dir=',$link,'">',basename($link),'</a>  / ';
		}
	}
	if($files!=null){
		echo '<a href="'.$link.$pics[$offset] .'">';
		echo $pics[$offset];
		echo '</a> ';
		echo '<a href="'.$link.$pics[$offset].'" download><img class="downloadicon" src="' . $iconpath . '/download.png" alt="dl">';
		echo '</a>';
	}
	echo '</div>';

	echo '<div id="view">';	
		echo '<a href="?view=jpg&dir='.$dir.'"><img alt="jpg" src="' . $iconpath . '/pictures.png" class="baricon2" ></a>';
		echo '<a href="?view=grid&dir='.$dir.'"><img alt="grid" src="' . $iconpath . '/application_view_icons.png" class="baricon2" ></a>';
		echo '<a href="?view=list&dir='.$dir.'"><img alt="list/" src="' . $iconpath . '/application_view_list.png" class="baricon2"></a>';
		echo '<a href="?about=1"><img alt="settings/" src="' . $iconpath . '/cog.png" class="baricon2" ></a>';
	echo '</div>';
echo '</div>';

}
function checkHtaccess($path){
	$result['enable']=true;
	$strlen = strlen($path);
    $testlen = strlen("/");
    if (substr_compare($path, "/", $strlen - $testlen, $testlen) !== 0){ 
		$path=$path . "/";
	}
	$htpath=$path . ".htaccess";
	$thumbdir=str_replace("/./","/",$GLOBALS["thumbPath"] . $path);
	$thumbhtaccess=$thumbdir . ".htaccess";
	#echo "path=".$path . "\r\n";
	#echo "thumbhtaccess=".$thumbhtaccess . "\r\n";
	#echo "thumbdir=".$thumbdir . "\r\n";
	#echo "htpath=".$htpath . "\r\n";
	if(file_exists($htpath)){
		if(!file_exists("./.htaccess")){
			if(!file_exists($thumbdir)){
				mkdir($thumbdir, 0755, true);
				chmod($thumbdir, 0755);
			}
			copy($htpath,$thumbhtaccess);
			$result['enable'] = false;
		}
		elseif(filesize("./.htaccess") == filesize($htpath) &&  
		       md5_file("./.htaccess") == md5_file($htpath)  )
		{
			$result['enable']=true;
		}
		else
		{	
			if(!file_exists($thumbdir)){
				mkdir($thumbdir, 0755, true);
				chmod($thumbdir, 0755);
			}
			copy($htpath,$thumbhtaccess);
			$result['enable'] = false;
		}
	}else{
		if(file_exists($thumbhtaccess)){
			unlink($thumbhtaccess);
		}
	}
		return $result;
}
function privatecheck($file,$privateFiles,$privateFolders){
	$file=trim($file,"./");
	$file=trim($file,"/");
	foreach ($privateFiles as $privateFile){	// Go through privatefiles and if matches remove it.
		$length = strlen($privateFile);
		if (strtolower(substr($file, -$length))===$privateFile){
			return false;
		}
	}
	foreach ($privateFolders as $privateFolder){	// Go through privatefiles and if matches remove it.
		$length = strlen($privateFolder);
		if(is_dir($file) && substr($file, -$length)===$privateFolder){
			return false;
		}
	}
	return true;
}
function removeExtra($files,$dir,$allowedDepth,$privateFiles,$privateFolders){
	$filestmp=array();			// Initialize array 
	$i = 0;
	foreach ($files['files'] as $file){// Loop the files
	
		if(substr( $file, 0, 1 )==="." ){	// if starts with . remove from list (current dir and previous dir)
			unset($files['files'][$i]);
			$i++;
			continue;		
		}

		if(!privatecheck($file,$privateFiles,$privateFolders)){
			unset($files['files'][$i]);
			$i++;
			continue;
		}

		if(is_dir($dir . $file))	// if file is dir and within allowedDepth limit add it to $folders array and delte from file array
		{
			if(substr_count($dir . $file,'/') < $allowedDepth+1){
				$result=checkHtaccess($dir . $file);
				if($result['enable']){
					$folders['folders'][$i] = $file;
				}
				elseif($GLOBALS['warnings'] && $GLOBALS['htwarnings']){
					echo "htaccess missmatch ",$dir . $file,"<br>";
				}
			}
			unset($files['files'][$i]);
		}
	$i++;
	}

	natcasesort($files['files']);		// sort files
	if(isset($folders)){		// if there is folders sort them and return folders and files both in one array where folders are first
		natcasesort($folders['folders']);
			return array_merge($folders,$files);	
	}else{				// if there is no folders only return files
		return $files;
	}
}

function infobar($iconpath){
echo '<div id="fileinfo3">';
	echo '<div class="spacer2">';	
		echo '&nbsp;';
	echo '</div>';

	echo '<div class="downloadlist">';
		echo	'<img class="downloadicon" src="' . $iconpath . '/download.png" alt="dl">';
	echo '</div>';
	
		echo '<div class="spacer2">';	
		echo '&nbsp';
	echo '</div>';
	
	
	echo '<div class="fileicon1">';
	echo '<img class="icon" src="' . $iconpath . '/pictures.png" alt="ico" >';	
	echo '</div>';



	echo '<div class="spacer2">';	
		echo '&nbsp';
	echo '</div>';
	
	
	
	echo '<div class="name">';	
		echo 'Filename';
	echo '</div>';
	

	
	echo '<div class="spacer">';	
		echo '&nbsp';
	echo '</div>';

	echo '<div class="type">';	
		echo 'Type';
	echo '</div>';

	echo '<div class="spacer">';	
		echo '&nbsp;';
	echo '</div>';
	echo '<div class="modified">';	
		echo 'Modified';
	echo '</div>';
	echo '<div class="spacer">';	
			echo '&nbsp;';
	echo '</div>';

		echo '<div class="filesize">';	
		echo 'Size';
	echo '</div>';
	echo '<div class="spacer">';	
		echo '&nbsp;';
	echo '</div>';
	
echo '</div>';
}
function loopfiles($files,$dir,$type,$iconpath,$view){
	if($type=="list"){
		$x=0;
		if(isset($files['folders'])){
			foreach($files['folders'] as $file){
				$test=true;
				if($test){
					filelist($file,$dir,$x++,$iconpath,$view);				
				}	
			}	
		}
		if(isset($files['files'])){
			foreach($files['files'] as $file){
				filelist($file,$dir,$x++,$iconpath,$view);	
			}	
		}
	}elseif($type=="grid"){
		echo '<div class="allcontainer">';
		if(isset($files['folders'])){
			foreach($files['folders'] as $file){
				$test=true;
				if($test){
					FileGrid($file,$dir,$iconpath,$view);				
				}	
			}	
		}
		if(isset($files['files'])){
			foreach($files['files'] as $file){
				FileGrid($file,$dir,$iconpath,$view);		
			}
		}
		echo '</div>';
	}elseif($type=="thumbs"){
		foreach($files['files'] as $file){
			if(in_array("." .strtolower(pathinfo($file, PATHINFO_EXTENSION)),$GLOBALS["supportedthumbs"])){ // check if filetype is in supportedthumbs array
				generatethumbs($file,$dir,$GLOBALS["thumbWidth"]);
			}
		}
	}elseif($type=="jpg"){
		if(isset($files['files'])){

			if(isset($_GET['pic'])){
				$offset=filter_input(INPUT_GET, 'pic', FILTER_VALIDATE_INT);
			}
			echo '<div class="fullcontainer">';
			if(isset($offset)){
				echo '<img class="full" src="'. $dir . $GLOBALS['pics'][0+$offset] .'">';
			}else{
				$offset=0;
				echo '<img class="full" src="' . $dir . $GLOBALS['pics'][0] .'">';	
			}
			echo '</div>';
			echo '</div>';
			$yy=0;


			if($offset!=0){
				echo '<div class="bottom">';
		     		echo '<div class="allign">';
				echo '<a href="?pic=0&view=jpg">';
				echo '<div class="first">';
				echo '<div class="buttonalign">';
				echo '&lt;&lt;';
				echo '</div>';
				echo '</div>';
				echo '</a>';
		     		if($offset>4){
					echo '<a href="?pic='.($offset-5).'&view=jpg">';
					echo '<div class="previous5">';
					echo '<div class="buttonalign">';
					echo '&lt;5';
					echo '</div>';
					echo '</div>';
					echo '</a>';
				}else{
					echo '<div class="previousg5">';
					echo '<div class="buttonalign">';
			     		echo '&lt;5';
			     		echo '</div>';
			     		echo '</div>';
		    		 }
		     		echo '<a href="?pic='.($offset-1).'&view=jpg">';
		     		echo '<div class="previous">';
				echo '<div class="buttonalign">';
				echo '&lt;';
				echo '</div>';
				echo '</div>';
				echo '</a>';
		     }else{
				echo '<div class="bottom">';
				echo '<div class="allign">';
				echo '<div class="firstg">';
				echo '<div class="buttonalign">';
				echo '&lt;&lt;';
				echo '</div>';
				echo '</div>';
				echo '<div class="previousg5">';
				echo '<div class="buttonalign">';
				echo '&lt;5';
				echo '</div>';
				echo '</div>';
				echo '<div class="previousg">';
				echo '<div class="buttonalign">';
				echo '&lt;';
				echo '</div>';
				echo '</div>';
		     }

		     $count=count($GLOBALS['pics']);
			foreach($GLOBALS['pics'] as $pic){
				if($yy==$offset){
					FileSelect($pic,$dir,$iconpath,$yy,true);
				}else{
					if((abs($yy-$offset))<4 || ((($yy)<7) && $offset==0) || ((($yy)<7) && $offset==1) || ((($yy)<7) && $offset==2)){
						FileSelect($pic,$dir,$iconpath,$yy,false);
					}elseif($offset==($count-1) && ($yy-$offset)>-7){
						FileSelect($pic,$dir,$iconpath,$yy,false);
					}elseif($offset==($count-2) && ($yy-$offset)>-6){
						FileSelect($pic,$dir,$iconpath,$yy,false);
					}elseif($offset==($count-3) && ($yy-$offset)>-5){
						FileSelect($pic,$dir,$iconpath,$yy,false);	
					}
				}
				$yy++;
			}
			if($offset!=($count-1)){
				echo '<a href="?pic='.($offset+1).'&view=jpg">';
				echo '<div class="next">';
				echo '<div class="buttonalign">';
				echo '&gt;';
				echo '</div>';
				echo '</div>';
				echo '</a>';
				if(($offset+5)<$count){
					echo '<a href="?pic='.($offset+5).'&view=jpg">';
					echo '<div class="next5">';
					echo '<div class="buttonalign">';
					echo '5&gt;';
					echo '</div>';
					echo '</div>';
					echo '</a>';
				}else{
					echo '<div class="nextg5">';
					echo '<div class="buttonalign">';
					echo '5&gt;';
					echo '</div>';
					echo '</div>';
				}
				echo '<a href="?pic='. ($count-1) .'&view=jpg">';
				echo '<div class="last">';
				echo '<div class="buttonalign">';
				echo '&gt;&gt;';
				echo '</div>';			
				echo '</div>';
				echo '</a>';
				echo '</div>';
				echo '</div>';
			}else{
				echo '<div class="nextg">';
				echo '<div class="buttonalign">';
				echo '&gt;';
				echo '</div>';
				echo '</div>';
				echo '<div class="nextg5">';
				echo '<div class="buttonalign">';
				echo '5&gt;';
				echo '</div>';
				echo '</div>';
				echo '<div class="lastg">';
				echo '<div class="buttonalign">';
				echo '&gt;&gt;';
				echo '</div>';			
				echo '</div>';
				echo '</div>';
				echo '</div>';	
			}

		}
		keypress($offset,$count,$dir);
	}
}
function keypress($offset,$count,$dir){
$previous=$offset-1;
$next=$offset+1;
if($previous<0){
	$previous=0;
}
if($next>=($count-1)){
	$next=($count-1);
}
	echo "
<script type=\"text/javascript\">

function leftArrowPressed() {
   location.href = \"?dir=$dir&pic=$previous&view=jpg\";
}

function rightArrowPressed() {
   location.href = \"?dir=$dir&pic=$next&view=jpg\";
}
document.onkeydown = function(evt) {
    evt = evt || window.event;
    switch (evt.keyCode) {
        case 37:
            leftArrowPressed();
            break;
        case 39:
            rightArrowPressed();
            break;
    }
};
$(window).load(function(){
 $('.fullcontainer').find('img').each(function(){
  var imgClass = (this.width/this.height > 1) ? 'wide' : 'tall';
  $(this).addClass(imgClass);
 })
})
</script>
";
}
function filelist($file,$dir,$x,$iconpath,$view){
	$odd=$x;
	$filepath=str_replace("/./","/",$dir.$file );
	$filepath = implode('/', array_map('rawurlencode', explode('/', $filepath)));
	$Lfilepath=$filepath;
	$thumbfilepath=str_replace("/./","/",$GLOBALS["thumbPath"]. $dir . $file);
	$Lthumbfilepath=$thumbfilepath;
	$thumbfilepath= implode('/', array_map('rawurlencode', explode('/', $thumbfilepath)));
	$filetype="";		
	if(is_dir($dir . $file)){
		$filetype="dir";
	}else{
		foreach($GLOBALS["supported"] as $filetypetest){
			$length = strlen($filetypetest);
			if (strtolower(substr($file, -$length)) === $filetypetest ){
				$filetype = strtolower(substr($file,-$length+1));
				break;
			}
		}
	}
	if( $odd % 2 == 0){
	     echo '<div class="fileinfo">';
	}else{
	     echo '<div class="fileinfo2">';
	}
	echo '<div class="spacer2">';	
	echo '&nbsp;';
	echo '</div>';
	echo '<div class="downloadlist">';
	if($filetype!="dir" && $filetype!="index.php"){
		echo '<a href="',$filepath,'" download="',$file,'" ><img class="downloadicon" src="' . $iconpath . '/download.png" alt="dl">';
		echo '</a>';
	}else{
		echo 	'<div class="cube">';	
		echo 	'&nbsp';
		echo '</div>';
	}
	echo '</div>';
	echo '<div class="spacer2">';	
	echo '&nbsp;';
	echo '</div>';
	echo '<div class="fileicon">';
	switch ($filetype):
		case "jpeg":
		case "jpg":
		case "png":
		case "gif":	
			echo '<a href="',$filepath,'">';
			echo '<img class="icon" src="', $thumbfilepath;
			echo '" alt="pic" >';
			echo '</a>';
			break;
		case "txt":
		case "log":
			echo '<a href="',$filepath,'" >';
			echo '<img class="icon" src="', $thumbfilepath . ".png";
			echo '" alt="txt" >';
			echo '</a>';
			break;
		case "dir":
			echo '<a href="?view='.$view.'&dir=',$filepath,'">';
			echo '<img alt="dir" src="' . $iconpath . '/folder.png" class="icon">';
			echo '</a>';
			break;
		case "pdf":
			echo '<a href="',$filepath,'">';
			echo '<img alt="pdf" src="' . $iconpath . '/page_white_acrobat.png" class="icon">';
			echo '</a>';
			break;	
		case "doc":
			case "docx":
			echo '<a href="',$filepath,'">';
			echo '<img alt="d" class="icon" src="' . $iconpath . '/page_word.png"  >';
			echo '</a>';
			break;			
		case "xls":
		case "xlsx":
			echo '<a href="',$filepath,'">';
			echo '<img alt="xls" class="icon" src="' . $iconpath . '/page_excel.png"  >';
			echo '</a>';
			break;			
		case "iso":
		case "img":
		case "bin":
			echo '<a href="',$filepath,'">';
			echo '<img alt="img" class="icon" src="' . $iconpath . '/page_white_dvd.png"  >';
			echo '</a>';
			break;			
		case "ppt":
		case "pptx":
			echo '<a href="',$filepath,'">';
			echo '<img alt="ppt" class="icon" src="' . $iconpath . '/page_white_powerpoint.png"  >';
			echo '</a>';
			break;	
		case "zip":
		case "rar":
		case "7z":
		case "tar":
		case "gz":
			echo '<a href="',$filepath,'">';
			echo '<img alt="zip" class="icon" src="' . $iconpath . '/compress.png"  >';
			echo '</a>';
			break;			
		default:
			echo '<a href="',$filepath,'">';
			echo '<img alt="!" class="icon" src="/icons/unknown.png"  >';	
			echo '</a>';						
			break;
	endswitch;
	echo '</div>';
	echo '<div class="spacer2">';	
	echo '&nbsp;';
	echo '</div>';
	echo '<div class="name">';	
	if($filetype=="dir"){			
		echo '<a href="?dir=',$filepath,'">',$file,"</a>";
	}elseif($filetype=="index.php"){
		echo '<a href="',dirname($filepath),'/?reset=1">',trim(dirname($filepath),"./"),'</a>';
	}else{
		echo '<a href="',$filepath,'">',$file,'</a>';
	}
	echo '</div>';
	echo '<div class="spacer">';	
	echo '&nbsp;';
	echo '</div>';
	echo '<div class="type">';	
	if($filetype!="dir" &&  $filetype != "index.php"){
		echo pathinfo($file, PATHINFO_EXTENSION);
	}else{
		echo "&nbsp;";
	}
	echo '</div>';
	echo '<div class="spacer">';	
	echo '&nbsp;';
	echo '</div>';
	echo '<div class="modified">';	
	if($filetype!="index.php"){
		echo  date("Y.m.d H:i",filemtime($dir.$file));		
	}else{
		echo date("Y.m.d H:i",filemtime(dirname($dir . $file)));
	}
	echo '</div>';
	echo '<div class="spacer">';	
	echo '&nbsp;';
	echo '</div>';
	echo '<div class="filesize">';	
	if($filetype!="dir" && $filetype!="index.php"){
		echo human_filesize(filesize($dir.$file));
	}else{
		echo "Folder";
	}
	echo '</div>';
	echo '<div class="spacer">';	
	echo '&nbsp;';
	echo '</div>';
	echo '</div>';	
}
function FileGrid($file,$dir,$iconpath,$view){
	$filetype="";
	$filepath=str_replace("/./","/",$dir.$file );
	$Lfilepath=$filepath;
	$filepath = implode('/', array_map('rawurlencode', explode('/', $filepath)));
	$thumbfilepath=str_replace("/./","/",$GLOBALS["thumbPath"]. $dir . $file);
	$Lthumbfilepath=$thumbfilepath;
	$thumbfilepath= implode('/', array_map('rawurlencode', explode('/', $thumbfilepath)));
	if(is_dir($dir . $file)){
		$filetype="dir";
	}else{
		foreach($GLOBALS["supported"] as $filetypetest){
			$length = strlen($filetypetest);
			if (strtolower(substr($file, -$length)) === $filetypetest ){
				$filetype = strtolower(substr($file,-$length+1));
				break;
			}
		}
	}	
	echo '<div class="container">';
		echo '<div class="pictures">';
			echo '<span class="helper"></span>';		
					switch ($filetype):	
						case "jpeg":
						case "jpg":
						case "png":
						case "gif":
							echo '<a href="',$filepath,'">';
							if(file_exists($Lthumbfilepath)){
								echo '<img class="picture" src="', $thumbfilepath;
								echo '" alt="',$dir.$file, ' thumb" >';	
							}else{
								echo "error";echo $thumbfilepath;
							}
							echo '</a>';
							break;
						case "txt":
						case "log":
							echo '<a href="',$filepath,'">';
							if(file_exists($Lthumbfilepath . ".png")){
								echo '<img class="picture" src="',$thumbfilepath . ".png";
								echo '" alt="',$dir.$file, ' thumb" >';
							}else{
								echo "error";echo $dir . $file . ".png";
							}
							echo '</a>';
							break;
						case "dir":
							echo '<a href="?view='.$view.'&dir=',$filepath,'">';
							echo '<img alt="Directory " src="' . $iconpath . '/folder.png" class="icon">',$file;
							echo '</a>';
							break;
						case "pdf":
							echo '<a href="',$filepath,'">';
							if(file_exists($Lthumbfilepath . ".jpg")){
								echo '<img class="picture" src="', $thumbfilepath . ".jpg";
								echo '" alt="',$dir.$file, ' thumb" >';
							}else{
								echo "error";
							}
							echo '</a>';
							break;	
						case "doc":
						case "docx":
							echo '<a href="',$filepath,'">';
							echo '<img alt="doc" class="thumb" src="' . $iconpath . '/page_word.png"  >';
							echo '</a>';
							break;			
						case "xls":
						case "xlsx":
							echo '<a href="',$filepath,'">';
							echo '<img alt="Excel file" class="thumb" src="' . $iconpath . '/page_excel.png"  >';
							echo '</a>';
							break;	
						case "iso":
						case "bin":
						case "img":
							echo '<a href="',$filepath,'">';
							echo '<img alt="disk image file" class="thumb" src="' . $iconpath . '/page_white_dvd.png"  >';
							echo '</a>';
							break;	
						case "ppt":
						case "pptx":
							echo '<a href="',$filepath,'">';
							echo '<img alt="Powerpoint file" class="thumb" src="' . $iconpath . '/page_white_powerpoint.png"  >';
							echo '</a>';
							break;		
						case "zip":
						case "rar":
						case "7z":
						case "tar":
						case "gz":
								echo '<a href="',$filepath,'">';
								echo '<img alt="Compressed file" class="thumb" src="' . $iconpath . '/compress.png"  >';
								echo '</a>';
								break;	
							default:
								echo "No thumbnail available";
								break;
					endswitch;
				echo '</div>';
			echo '<div class="container2">';
				if($filetype=="dir" || $filetype=="index.php"){}else{
				echo '<div class="picturetext">';
					echo "&nbsp;";
					echo '<a href="',$filepath,'">',$file; 
					echo '</a>'," ";
				echo '</div>';
				echo '<div class="download">';
					echo '<a href="',$filepath,'" download="',$file,'" ><img src="' . $iconpath . '/download.png" alt="dl">';
					echo '</a>';
					echo '</div>';
				}

			echo '</div>';
		echo '</div>';
	return 1;
}

function FileSelect($file,$dir,$iconpath,$index,$selected){
	$filetype="";
	$filepath=str_replace("/./","/",$dir.$file );
	$Lfilepath=$filepath;
	$filepath = implode('/', array_map('rawurlencode', explode('/', $filepath)));
	$thumbfilepath=str_replace("/./","/",$GLOBALS["thumbPath"]. $dir . $file);
	$Lthumbfilepath=$thumbfilepath;
	$thumbfilepath= implode('/', array_map('rawurlencode', explode('/', $thumbfilepath)));
	if(is_dir($dir . $file)){
		$filetype="dir";
	}else{
		foreach($GLOBALS["supported"] as $filetypetest){
			$length = strlen($filetypetest);
			if (strtolower(substr($file, -$length)) === $filetypetest ){
				$filetype = strtolower(substr($file,-$length+1));
				break;
			}
		}
	}	
	if($selected){
		echo '<div class="currentselectcontainer">';	
	}else{
		echo '<div class="selectcontainer">';
	}
	
		echo '<div class="selectpictures">';
			echo '<span class="helper"></span>';		
					switch ($filetype):	
						case "jpeg":
						case "jpg":
						case "png":
						case "gif":
							echo '<a href="?pic=',$index,'&view=jpg">';
							if(file_exists($Lthumbfilepath)){
								echo '<img class="selectpicture" src="', $thumbfilepath;
								echo '" alt="',$dir.$file, ' thumb" >';	
							}else{
								echo "error";echo $thumbfilepath;
							}
							echo '</a>';
							break;
						default:
							echo "No thumbnail available";
							break;
					endswitch;
				echo '</div>';
			echo '<div class="selectcontainer2">';
				if($filetype=="dir" || $filetype=="index.php"){}else{
				echo '<div class="selectpicturetext">';
					echo "&nbsp;";
					echo '<a href="',$filepath,'">',$file; 
					echo '</a>'," ";
				echo '</div>';
				echo '<div class="selectdownload">';
					echo '<a href="',$filepath,'" download="',$file,'" ><img src="' . $iconpath . '/download.png" alt="dl">';
					echo '</a>';
					echo '</div>';
				}

			echo '</div>';
		echo '</div>';
	
	return 1;
}

function generatethumbs($file,$dir,$thumbWidth){ /// Generates the thumbnails 
	if(!file_exists("/usr/share/httpd/icons/fv/") && !file_exists("/usr/share/apache2/icons/fv/") && !file_exists("/var/www/icons/")&& !file_exists("./.icons/")){
		if($GLOBALS['warnings']){
			echo "Warning: icon folder doesn't exist, some icons will be shown as text<br>";
		}
	}
	if(file_exists("/usr/share/httpd/icons/fvh/DroidSansMono.ttf")){
		$font="/usr/share/httpd/icons/fv/DroidSansMono.ttf";  // Font for generating thumbnails of txt files
	}elseif(file_exists("/usr/share/apache2/icons/fv/DroidSansMono.ttf")){
		$font="/usr/share/apache2/icons/fv/DroidSansMono.ttf";
	}elseif(file_exists("/var/www/icons/fv/DroidSansMono.ttf")){
		$font="/var/www/icons/fv/DroidSansMono.ttf";
	}elseif(file_exists("./.icons/DroidSansMono.ttf")){
		$font="./.icons/DroidSansMono.ttf";
	}else{
		if($GLOBALS['warnings']){
			echo "Warning: Couldn't find font file, won't be generating txt and log thumbs.<br>";
		}
		$font=false;
	}
	$i = 0;
	$status=true;			
	$thumbdir=str_replace("/./","/",$GLOBALS["thumbPath"] . $dir); 	// Remove extra /./ from the path
	if (!file_exists($thumbdir)){					// Create the thumbnail folder if it doesn't exist
		$status=mkdir($thumbdir, 0755, true);
		chmod($thumbdir, 0755);
	}
	if(!$status && $GLOBALS['warnings'] ){							// Display error if creating the folder failed
		echo 'error creating folder ="',$thumbdir,'", check permissions<br>';
		echo 'Create folder called ".thumbs" in the same folder as this script and give all users read, write and access rights<br>';
		echo 'Example<br> ';
		echo 'mkdir ./.thumbs<br>';
		echo 'chmod a+rwx ./.thumbs/';
	}
	elseif(!is_writable($thumbdir) && $GLOBALS['warnings']){				// Display error if the thumbnail directory is not writable
		echo 'error while trying to write in ="',$thumbdir,'", check permissions<br>';
		echo 'Folder called ".thumbs" in the same folder as this script must have read, write and acess rights for all<br>';
		echo 'Example<br> ';
		echo 'chmod a+rwx ./.thumbs/';
	}else{								// if nothing failed goes here
		if (!file_exists($thumbdir . "index.html")){touch($thumbdir . "index.html");} //creates empty index file for thumbnail folder
		$filepath= $dir.$file;			
		$thumbfilepath = $thumbdir . $file;
		$testpath=$thumbfilepath;
		$ext=pathinfo($file, PATHINFO_EXTENSION);
		if($ext=="pdf"){
		$testpath=$testpath . ".jpg";
		}elseif($ext=="log" || $ext=="txt"){
		$testpath=$testpath . ".png";
		}
		if(( !file_exists($thumbfilepath) && ! file_exists( $thumbfilepath . ".png") && ! file_exists( $thumbfilepath . ".jpg"))  || ( filemtime($testpath) < filemtime($filepath))){ // if thumbnail doesn't exist or file is newer than the thumbnail
			foreach($GLOBALS["supportedthumbs"] as $filetype){	//loops through supported files
				$length = strlen($filetype);			
				if (substr($file, -$length) === $filetype || strtolower(substr($file, -$length)) === $filetype ){ // if file type matches with supported file type
					switch (strtolower(substr($file, -$length+1))): // Cut file name to just file type and make it lower case.
						case "pdf":
							if(extension_loaded('imagick')){
								$output=shell_exec ('pdfinfo ' . $filepath . ' | grep -c "Mac OS X 10..\?... Quartz PDFContext"');
								$gsversion=shell_exec('/usr/bin/gs --version 2>&1 ');
								if($output==0 || $gsversion>8.70){
									$imagick = new Imagick(); 			// Create the variable
									$imagick->setResolution(50, 50);		// Set dpi to 50
									$imagick->readImage($filepath . '[0]');		// Read first page of the pdf
									$imagick = $imagick->flattenImages();  		// Combine layers
									$resolution= $imagick->getImageGeometry();;	// Get image size
									$newWidth = $thumbWidth;			
									$newHeight=floor($resolution['height']/2);	
									$imagick->cropImage($newWidth, $newHeight, 0.03 * $resolution['width'], 0.03 * $resolution['height']); // crop the image with and focus a little bit
									$imagick->writeImages($thumbfilepath . ".jpg", false); 	// Write the image
									chmod($thumbfilepath . ".jpg", 0644);
								}elseif($GLOBALS['pdfQuartzwarnings']==true){
									echo $filepath . ", Mac OS X Quartz PDFContext genrated pdf have problem with GPL Ghostscript 8.70 thumbnail disabled<br>";
								}
							}elseif($GLOBALS['warnings']){
								echo "Warning: Can't find php extension Imagick. PDF thumbnail generation is disabled.<br>";
							}
							break;
						case "jpeg":
						case "jpg":
							if(function_exists('imagecreatefromjpeg')){
								$img = imagecreatefromjpeg($filepath);		// Read the image
								$width = imagesx ( $img );			// Get the width
								$height = imagesy ( $img );			// Get the height
								$newWidth = $thumbWidth;
								$newHeight = floor ( $thumbWidth * ( $height / $width ) ); // Calculate the new height
								$tmpImg = imagecreatetruecolor( $newWidth, $newHeight );   // initialize the variable
								imagecopyresized( $tmpImg,$img,0,0,0,0,$newWidth,$newHeight,$width,$height); // save the thumbnail to variable 
								imagejpeg( $tmpImg, $thumbfilepath);		// Write the file
								chmod($thumbfilepath, 0644);
							}else{
								echo "Function imagecreatefromjpeg not loaded<br>";
							}
							break;
						case "png":
							if(function_exists('imagecreatefrompng')){	
									$img = imagecreatefrompng($filepath);
									$width = imagesx ( $img );
									$height = imagesy ( $img );
									$newWidth = $thumbWidth;
									$newHeight = floor ( $thumbWidth * ( $height / $width ) );
									$tmpImg = imagecreatetruecolor( $newWidth, $newHeight );
									imagecopyresized( $tmpImg,$img,0,0,0,0,$newWidth,$newHeight,$width,$height);
									imagepng( $tmpImg, $thumbfilepath);
									chmod($thumbfilepath, 0644);
							}else{
								echo "Function imagecreatefrompng not loaded<br>";
							}
							break;
						case "gif":
							if(function_exists('imagecreatefromgif')){	
								$img = imagecreatefromgif($filepath);
								$width = imagesx ( $img );
								$height = imagesy ( $img );
								$newWidth = $thumbWidth;
								$newHeight = floor ( $thumbWidth * ( $height / $width ) );
								$tmpImg = imagecreatetruecolor( $newWidth, $newHeight );
								imagecopyresized( $tmpImg,$img,0,0,0,0,$newWidth,$newHeight,$width,$height);
								imagegif( $tmpImg, $thumbfilepath);
								chmod($thumbfilepath, 0644);
							}else{
								echo "Function imagecreatefromgif not loaded<br>";
							}
							break;
						case "log":
						case "txt":
							if(function_exists('imagecreatetruecolor') && function_exists('imagettftext') ){
								if($font){
									$newWidth = $thumbWidth;
									$newHeight = $thumbWidth;
									$tmpImg = imagecreatetruecolor( 400, 300 );			// initialize the variable
									$text_color = imagecolorallocate($tmpImg, 0, 0, 0);		// Set the text colour
									$background_color = imagecolorallocate($tmpImg, 255, 255, 255);	// Set the background colour
									imagefill ($tmpImg,0,0,$background_color);			// Paint the background
									$handle = fopen($filepath, "r");				// Open the source txt
									$y=14;								// Height where to start the text
									if($handle){							// if while was opened 
										while (($line = fgets($handle)) !== false) {		// loop the lines of the txt
											imagettftext($tmpImg, 10,0,0,$y,$text_color,$font,substr($line,0,-1));	// write the txt to the variable line by line
											//imagestring($tmpImg, 4, 0, $y,substr($line,0,-1), $text_color);	// not so pretty way to do it
											$y+=14;									// go one line down in the picture
											if($y>315){
												break;							// break after ~20 lines
											}
										}
									 	fclose($handle);					// Close the source file
	 									imagepng( $tmpImg, $thumbfilepath.".png");		// Save png file
										 chmod($thumbfilepath.".png", 0644);
									}elseif($GLOBALS['warnings']){
										echo "error reading txt file<br>";
									}
								}
							}else{
								echo "Function imagecreatetruecolor or imagettftext not loaded.<br>";
							}
							break;
						default:
							break;
					endswitch;
					break;
				}
							
			}
				
		}			
	}
}
?> 

</body>
</html> 
